<?
# нужное подключаем
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($INCLUDE_FOLDER."index.php");

class SPE_ajax{
    
    /**
    *  массив для сбора json-ответа 
    */
    var $response=array();
    
    /**
    * массив для сбора json ошибок
    */
    var $errors=array();
    
    function process_request(){
        global $nc_core;
        $action = $_POST['action'];
        switch($action){
            case 'set_ok_admin_return_url':
                $_SESSION['SPE_ok_return_to'] = $_POST['url'];
                break;
            case 'set_album_id':
                // допускаем установку id альбома только для тех, где он не указан 
                $nc_core->db->query("
                    update Subdivision 
                    set `SPE_".$_POST['type']."_ALBUM_ID` = ".mysql_real_escape_string($_POST['aid'])." 
                    WHERE Subdivision_ID=".mysql_real_escape_string($_POST['sub'])." 
                        AND `SPE_".$_POST['type']."_ALBUM_ID`=''
                ");
                break;
            case 'upload_photo_VK':
                $url = $_POST['url'];
                // данные формы, наряду с отправляемым файлом
                $i = 1;
                foreach($_POST['photos'] as $photo){
                    $postData['file'.$i] = "@".$_SERVER['DOCUMENT_ROOT'].$photo;
                    $i++;
                }
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                // отсылаем запрос
                curl_exec($ch);
                curl_close($ch);
                exit();
                break;
            case 'set_uploaded_photo_VK':
                foreach($_POST['photos'] as $key=>$path){
                    SPExport::setQueueFileId($path,'VK',$_POST['response'][$key]['id']);    
                }
                break;
            case 'set_uploaded_photo_FB':
                SPExport::setQueueFileId($_POST['path'],'FB',$_POST['id']); 
                break; 
            case 'export_ok':
                $sub = $nc_core->input->fetch_get_post('sub');
                $Sub_Class_ID = $nc_core->input->fetch_get_post('sub_class');
                if(empty($sub)){
                    $this->errors[] = 'no sub';
                }elseif(empty($Sub_Class_ID)){
                    $this->errors[] = 'no Sub_Class_ID';
                }else{
                    $SPExport = new SPExport($sub);
                    $SPExport->ok_export($Sub_Class_ID);
                }
                break;
        }
        $this->_echo_response();    
    }
    
    
    /**
    * проверяет наличие ошибок в $this->errors и выводит ответ либо сообщение
    * @param bool оборачивать ли ответ в htmlspecialchars()
    * @param bool отправлять ли заголовок json
    * @param string куда скинуть пользователя, если запрос не аяксовый(по дефолту - HTTP_REFERER)
    * @param bool не стирать данные в response при ошибках
    */
    protected function _echo_response($htmlspecialchars=false,$send_header=true,$no_ajax_redirect_url='',$keep_response_on_error=false){
        // ошибок нет?
        if(empty($this->errors)){
            unset($this->errors);
            $this->response['success']=true; // ставим флаг
        }else{
            // собираем сообщение об ошибке
            $this->_make_errors($keep_response_on_error);
        }
        if($send_header){
            // шлём заголовок
            header('Content-type: text/json;');    
        }
        // перегоряем ответ в JSON - строку
        $str = json_encode($this->response);
        if($htmlspecialchars){
            // конвертируем спецсимволы
            $str = htmlspecialchars($str, ENT_NOQUOTES);
        }
        // отдаем ответ
        echo $str;
        exit();
    }
     
    /**
    * модифицирует ответ в случае наличия ошибок 
    */
    protected function _make_errors($keep_response_on_error=false){
        if(!$keep_response_on_error)
            $this->response=array('success'=>false);   // чистим массив ответа
        else{
            $this->response['success']=false;  // ставим только статус
        }
        $this->response['error']=join("\n",$this->errors);
        $this->response['errors']=$this->errors;
    }
    
}
$ajax = new SPE_ajax();
$ajax->process_request();

